#include "asm86.h"
#include "ti86asm.inc"

Lovecnt = $80DF
FIRSTCNT = $80E0
LASTCNT = $80E1
AMOUNT  = $80E2
NAMECNT = $80E3
TempCnt = $80E4

_setxxOP1   equ   4613h   ;Convert hex # in a to flt point in OP1
_setxxxxOP2 equ   461bh   ;Convert hex # in hl to flt point in OP2
_setxxOP2   equ   4617h   ;Convert hex # in a to flt point in OP2

.org _asm_exec_ram 

 nop
 jp THEPIC
 .dw $0000
 .dw shelldisc

THEPIC:
 ld hl,Pic                                              ; we will display the RLE at Pic
 ld de,$fc00                                    ; we will decompress it to video memory
 call DispRLE                                   ; show our cool picture
GGG:
 call _getkey
 cp kEnter
 jp z,THESTART
 cp kExit
 jp z,NameAbort
 jr GGG
THESTART:
 call _runindicoff
 call _clrScrn
 call $4A95			;This makes cursor go to 0,0
 ld a,0
 ld (Lovecnt),a			;Clearing our variables
 ld (FIRSTCNT),a
 ld (LASTCNT),a
 ld (AMOUNT),a
 set 2,(iy+12)			;Alpha lock Sort of :(
 set 6,(iy+18)			;Cursor on!
 set 3,(iy+05)			;Inverse Text On
 ld hl,topmessage
 call _puts
 ld hl,7
 ld (_curRow),hl
 ld hl,1
 ld (_curCol),hl
 ld hl,bottommessage
 call _puts 
 res 3,(iy+05)
 ld hl,1
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,firststring
 call _puts
 ld hl,2
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,thecolon
 call _puts
 ld a,1
 ld (NAMECNT),a
KeyCheck:
 call _getkey
 cp kEnter
 jp z, NameDone
 cp kExit
 jp z, NameAbort
 cp kClear
 jp z, Erase
 cp a
 jp z, Dispkey
 jp KeyCheck
Erase:
 ld a,(NAMECNT)
 cp 1
 jp z, THESTART
 ld a,(TempCnt)
 ld b,a
 ld a,(Lovecnt)
 sub b
 ld (Lovecnt),a
 ld a,0
 ld (LASTCNT),a
 
;
 call _clrScrn
 ld hl,0
 ld (_curRow),hl
 ld (_curCol),hl
 set 3,(iy+05)
 ld hl,topmessage
 call _puts
 res 3,(iy+05)
 ld hl,1
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,secondstring
 call _puts
 ld hl,2
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,thecolon
 call _puts
 jp KeyCheck

Dispkey:
 push af
 ld a,(NAMECNT)
 cp 1
 jp nz, SecondCnt
 ld a,(FIRSTCNT)
 inc a
 ld (FIRSTCNT),a
 jp AfterCnt
SecondCnt:
 ld a,(LASTCNT)
 inc a
 ld (LASTCNT),a
AfterCnt:
 pop af
 cp 39
 jp nz,NoSpace
 ld a, 7
NoSpace:
 add a, 25                              ;keycode-->char code
 cp 32
 jp z, Resume
 cp 65
 jp c,KeyCheck
Resume:
 cp 91
 jp nc,KeyCheck
 ld (hl), a
 call _putc
 jp Doadd

NameDone:
 ld a,32
 ld (hl), a
 call _putc
 ld a,(NAMECNT)
 cp 1
 jp nz, Dofigure
 ld a,0
 ld (TempCnt),a
 res 2,(iy+12)
 ld a,2
 ld (NAMECNT),a
 ld a,0
 ld hl,(_curRow)
 inc hl
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,secondstring
 call _puts
 ld hl,(_curRow)
 inc hl
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl,thecolon
 call _puts
 set 2,(iy+12)
 jp KeyCheck
Dofigure:
 ld a,(LASTCNT)
 ld b,a
 ld a,(FIRSTCNT)
 add a,b
 cp 0
 jp z,bothzip
 ld d,0
 ld e,a
DaLoop:
 ld a,d
 inc a
 ld d,a
 ld a,e
 sub 2
 cp 1
 jr z, NotInteger
 cp 2
 jp c,ResultFound
 ld e,a
 jr DaLoop
NotInteger:
 ld a,d
 inc a
 ld d,a
ResultFound:
 ld a,d
 ld (FIRSTCNT),a
 ld a,(Lovecnt)
 cp 0
 jp z, G1
 jp c, G1
 ld d,5
G1:
 cp 2
 jp z, G2
 jp c, G2
 ld d,10
G2:
 cp 4
 jp z, G3
 jp c, G3
 ld d,20
G3:
 cp 6
 jp z, G4
 jp c, G4
 ld d,30
G4:
 cp 8
 jp z, G5
 jp c, G5
 ld d,40
G5:
 cp 10
 jp z, G6
 jp c, G6
 ld d,50
G6:
 cp 12
 jp z, G7
 jp c, G7
 ld d,60
G7:
 cp 14
 jp z, G8
 jp c, G8
 ld d,70
G8:
 cp 16
 jp z, G9
 jp c, G9
 ld d,80
G9:
 cp 18
 jp z, G10
 jp c, G10
 ld d,90
G10:
 cp 20
 jp z, G11
 jp c, G11
 ld d,100
G11:
 cp 22
 jp z, G12
 jp c, G12
 ld d,110
G12:
 ld a,(FIRSTCNT)
 ld b,a
 ld a,d
 sub b
 cp 100
 jp nc, Make99
 cp 0
 jp c, Make0
 jp Continue
Make99:
 ld a,99
 jp Continue
Make0:
 ld a,0
Continue:
 ld (AMOUNT),a
 ld d,0
 ld e,a
TheLoop:
 ld a,d
 inc a
 ld d,a
 ld a,e
 sub 10
 cp 10
 jp c,TheResult
 ld e,a
 jr TheLoop
TheResult:
 ld (LASTCNT),a
 ld d,0                                 ;Clearing d
 ld a,(AMOUNT)                          ;Loading total into A
 ld e,a                                 ;Loading A (TOTAL) into E
TheLoop2:
 ld a,d                                 ;A equals counter value
 inc a                                  ;Increase counter value
 ld d,a                                 ;Load new figure into D
;
 ld a,e                                 ;Load TOTAL into a
 sub 10                                 ;Take 10 away from TOTAL
 cp 10                                  ;Check to see if it's 10
 jp c,TheResult2                        ;If less than, jump to end
 ld e,a                                 ;Load New TOTAL into E
 jr TheLoop2                            ;Jump to Start of Loop
TheResult2:
 ld a,d
 ld (FIRSTCNT),a
 jp DispResult

;:int (amount/10)L1
;:int (amount-(L1*10))L2


; These are the commands I used in the basic version
; I ported them to ASM above

;:If LVECT>0:5-((lngth first+lngth second)/2)amount
;:If LVECT>2:10-((lngth first+lngth second)/2)amount
;:If LVECT>4:20-((lngth first+lngth second)/2)amount
;:If LVECT>6:30-((lngth first+lngth second)/2)amount
;:If LVECT>8:40-((lngth first+lngth second)/2)amount
;:If LVECT>10:50-((lngth first+lngth second)/2)amount
;:If LVECT>12:60-((lngth first+lngth second)/2)amount
;:If LVECT>14:70-((lngth first+lngth second)/2)amount
;:If LVECT>16:80-((lngth first+lngth second)/2)amount
;:If LVECT>18:90-((lngth first+lngth second)/2)amount
;:If LVECT>20:100-((lngth first+lngth second)/2)amount
;:If LVECT>22:110-((lngth first+lngth second)/2)amount


 
Doadd:
 cp 76
 jp z, L
 cp 79
 jp z, O
 cp 86
 jp z, V
 cp 69
 jp z, E
 cp 89
 jp z, Y
 cp 85
 jp z, U
 jp KeyCheck
L:
 ld a,(Lovecnt)
 add a,2
 ld d,2
 ld (Lovecnt),a
 jp KeyCheck2
O:
 ld a,(Lovecnt)
 add a,3
 ld d,3
 ld (Lovecnt),a
 jp KeyCheck2
V:
 ld a,(Lovecnt)
 add a,2
 ld d,2
 ld (Lovecnt),a
 jp KeyCheck2
E:
 ld a,(Lovecnt)
 add a,2
 ld d,2
 ld (Lovecnt),a
 jp KeyCheck2
Y:
 ld a,(Lovecnt)
 add a,3
 ld d,3
 ld (Lovecnt),a
 jp KeyCheck2
U:
 ld a,(Lovecnt)
 add a,3
 ld d,3
 ld (Lovecnt),a
 jp KeyCheck2
KeyCheck2:
 ld a,(TempCnt)
 add a,d
 ld (TempCnt),a
 jp KeyCheck
NameAbort:
 res 2,(iy+12)
 res 6,(iy+18)
 call _clrScrn
 call $4A95
 ret
bothzip:
 ld a,0
 ld (FIRSTCNT),a
 ld (LASTCNT),a
DispResult:
 ld a,0
 ld (Lovecnt),a
 ld a,1
 ld (NAMECNT),a
 call _clrScrn
THETOP:
 cp 1
 jp z,first
 ld a,(LASTCNT)
 jr TheDisplay
first:
 ld a,(FIRSTCNT)
TheDisplay:
 cp 1
 jp z, NUM1
 cp 2
 jp z, NUM2
 cp 3
 jp z, NUM3
 cp 4
 jp z, NUM4
 cp 5
 jp z, NUM5
 cp 6
 jp z, NUM6
 cp 7
 jp z, NUM7
 cp 8
 jp z, NUM8
 cp 9
 jp z, NUM9
 jp NUM0
NUM1:
 call LC
 call LD
 jp theend
NUM2:
 call LB
 call LC
 call LE
 call LF
 call LG
 jp theend
NUM3:
 call LC
 call LD
 call LE
 call LF
 call LG
 jp theend
NUM4:
 call LA
 call LC
 call LD
 call LF
 jp theend
NUM5:
 call LA
 call LD
 call LE
 call LF
 call LG
 jp theend
NUM6:
 call LA
 call LB
 call LD
 call LE
 call LF
 call LG
 jp theend
NUM7:
 call LC
 call LD
 call LE
 jp theend
NUM8:
 call LA
 call LB
 call LC
 call LD
 call LE
 call LF
 call LG
 jp theend
NUM9:
 call LA
 call LC
 call LD
 call LE
 call LF
 call LG
 jp theend
NUM0:
 call LA
 call LB
 call LC
 call LD
 call LE
 call LG
 jp theend
LA:
 ld d,10
MiniLoopA:
 inc d
 ld e,40
 ld a,(NAMECNT)
 cp 1
 jp z, contA
 ld a,28
 add a,e
 ld e,a
contA:
 call FindPixel
 or (hl)
 ld (hl),a
 ld a,d
 cp 31
 jp z,thereturn
 jp MiniLoopA
thereturn:
 ret
LB:
 ld d,31
MiniLoopB:
 inc d
 ld e,40
 ld a,(NAMECNT)
 cp 1
 jp z, contB
 ld a,28
 add a,e
 ld e,a
contB:
 call FindPixel
 or (hl)
 ld (hl),a
 ld a,d
 cp 53
 jp z,thereturn
 jp MiniLoopB
LC:
 ld d,10
MiniLoopC:
 inc d
 ld e,60
 ld a,(NAMECNT)
 cp 1
 jp z, contC
 ld a,28
 add a,e
 ld e,a
contC:
 call FindPixel
 or (hl)
 ld (hl),a
 ld a,d
 cp 31
 jp z,thereturn
 jp MiniLoopC
LD:
 ld d,31
MiniLoopD:
 inc d
 ld e,60
 ld a,(NAMECNT)
 cp 1
 jp z, contD
 ld a,28
 add a,e
 ld e,a
contD:
 call FindPixel
 or (hl)
 ld (hl),a
 ld a,d
 cp 53
 jp z,thereturn
 jp MiniLoopD
LE:
 ld e,39
 ld a,(NAMECNT)
 cp 1
 jp z, MiniLoopE
 ld a,28
 add a,e
 ld e,a
MiniLoopE:
 inc e
 ld d,11
 call FindPixel
 or (hl)
 ld (hl),a
 ld b,60
 ld a,(NAMECNT)
 cp 1
 jp z,lblE
 ld b,88
lblE:
 ld a,e
 cp b
 jp z,thereturn
 jp MiniLoopE
LF:
 ld e,39
 ld a,(NAMECNT)
 cp 1
 jp z, MiniLoopF
 ld a,28
 add a,e
 ld e,a
MiniLoopF:
 inc e
 ld d,32
 call FindPixel
 or (hl)
 ld (hl),a
 ld b,60
 ld a,(NAMECNT)
 cp 1
 jp z,lblF
 ld b,88
lblF:
 ld a,e
 cp b
 jp z,thereturn
 jp MiniLoopF
LG:
 ld e,39
 ld a,(NAMECNT)
 cp 1
 jp z, MiniLoopG
 ld a,28
 add a,e
 ld e,a
MiniLoopG:
 inc e
 ld d,53
 call FindPixel
 or (hl)
 ld (hl),a
 ld b,60
 ld a,(NAMECNT)
 cp 1
 jp z,lblG
 ld b,88
lblG:
 ld a,e
 cp b
 jp z,thereturn
 jp MiniLoopG
theend:
 ld a,(NAMECNT)
 cp 1
 jp nz, end
 ld a,2
 ld (NAMECNT),a
 jp THETOP
end:
 ld hl,7
 ld (_curRow),hl
 ld (_curCol),hl
 ld hl,percent
 call _puts
 ld hl,0
 ld (_curRow),hl
 ld (_curCol),hl
 res 2,(iy+12)
 res 6,(iy+18)
TIMETOCHOOSE:
 call _getkey
 cp kEnter
 jp z, CHOOSE2
 jr TIMETOCHOOSE
CHOOSE2:
 set 3,(iy+05)			;Inverse Text Set 
 ld hl,0
 ld (_curRow),hl
 ld (_curCol),hl
 ld hl,exitquits
 call _puts
 ld hl,7
 ld (_curRow),hl
 ld hl,0
 ld (_curCol),hl
 ld hl, enterinputs
 call _puts
 ld hl,0
 ld (_curRow),hl
 ld (_curCol),hl 
 res 3,(iy+05)			;Inverse Text Reset
CHOOSE:
 call _getkey
 cp kEnter
 jp z, THESTART
 cp kExit
 jp z, NameAbort
 jr CHOOSE  



; =============================================================
; Dan Eble & James Yopp FindPixel routine
; Input:  D = y, E = x
; Output: HL= addr in vid mem, A = bitmask, C is modified
; =============================================================
FindPixel:
    ld hl,FP_Bits
    ld a,e
    and $07         ; a = bit offset
    add a,l
    ld l,a
    adc a,h
    sub l
    ld h,a
    ld c,(hl)       ; c = bitmask for (hl)
;48 t-states up to this point
    ld hl,FP_RLD
    ld (hl),d
    ld a,e          ; a = x/8 (byte offset within row)
    rrca
    rrca   
    rrca
    rld
    or $FC 
    ld l,(hl)
    ld h,a          ; hl -> byte in vid mem
    ld a,c          ; now a = bitmask for (hl)
;121 t-states up to this point
    ret

FP_RLD:  .db $00
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01

;===========================================================
; RLE picture displayer v1.1
; Decodes a RLE picture made by RLE2PIC
;
; written by David Phillips <electrum@tfs.net>
; started: 8/19/98
; last update: 11/5/98
;
; input: HL = RLE encoded picture, DE = where to display
; output: 1024 byte decoded picture
; destroys: AF, BC, DE, HL
; current size: 32 bytes
;===========================================================
DispRLE:
 ld bc,1024                     ; we need to copy 
DispRLEL:
 ld a,(hl)                      ; get the next byte
 cp $91                         ; is it a run?
 jr z,DispRLERun        ; then we need to decode the run
 ldi                            ; copy the byte, and update counters
DispRLEC:
 ld a,b                         ; check the low byte and
 or c                           ; the high byte for 0
 jr nz,DispRLEL         ; if not, then we're not done either
 ret                            ; if it's zero, we're done
DispRLERun:
 inc hl                         ; move to the run value
 ld a,(hl)                      ; get the run value
 inc hl                         ; move to the run count
 push hl                        ; save source pointer
 ld h,(hl)                      ; get the run count
 ex de,hl                       ; swap source and destination pointers
DispRLERunL:
 ld (hl),a                      ; copy the byte
 inc hl                         ; increase destination pointer
 dec bc                         ; decrease byte count
 dec d                          ; decrease run count
 jr nz,DispRLERunL      ; if we're not done, then loop
 ex de,hl                       ; swap pointers back
 pop hl                         ; recover source pointer
 inc hl                         ; advance the source pointer
 jr DispRLEC            ; check to see if we should loop


;String variables used by Love Calculator 86 by Brian Overman - 1999 - 2000

shelldisc:
	.db "Love Calculator 86!",0
topmessage:
	.db "Press ALPHA to input!",0
bottommessage:
	.db "Love Calculator 86!",0
firststring:
	.db "Enter first person",0
thecolon:
	.db ":",0
secondstring:
	.db "Enter second person",0
exitquits:
	.db "Push EXIT to Leave!!",0
percent:
	.db "Percent",0
enterinputs:
	.db "Push ENTER to Input!",0


Pic:
; compressed picture made with PIC2RLE
; PIC2RLE by David Phillips <david@acz.org>


 .db $91,$00,$45,$04,$00,$03,$06,$0e,$60,$91,$00,$0a
 .db $04,$25,$24,$32,$6a,$80,$91,$00,$0a,$04,$55,$54
 .db $52,$8e,$e0,$91,$00,$0a,$04,$55,$64,$52,$8a,$a0
 .db $91,$00,$0a,$07,$22,$33,$32,$6e,$e0,$91,$00,$5f
 .db $e0,$91,$00,$0f,$1f,$91,$00,$10,$e0,$91,$00,$0a
 .db $03,$e0,$0f,$80,$00,$e0,$91,$00,$0a,$0f,$f8,$3f
 .db $e0,$03,$20,$91,$00,$0a,$1f,$fc,$7f,$f0,$04,$20
 .db $91,$00,$0a,$3f,$fe,$ff,$f8,$18,$20,$91,$00,$0a
 .db $3f,$fe,$ff,$f8,$20,$20,$91,$00,$0a,$7f,$ff,$ff
 .db $fc,$c0,$20,$91,$00,$0a,$7f,$91,$ff,$03,$00,$20
 .db $91,$00,$0a,$7f,$ff,$ff,$fc,$00,$20,$91,$00,$0a
 .db $7f,$ff,$ff,$fc,$91,$00,$0c,$7f,$ff,$ff,$fc,$91
 .db $00,$0c,$3f,$ff,$ff,$f8,$91,$00,$0c,$3f,$ff,$ff
 .db $f8,$91,$00,$0c,$1f,$ff,$ff,$f0,$91,$00,$0c,$0f
 .db $ff,$ff,$e0,$91,$00,$0c,$07,$ff,$ff,$c0,$91,$00
 .db $0c,$03,$ff,$ff,$80,$91,$00,$0c,$01,$ff,$ff,$91
 .db $00,$0d,$01,$ff,$ff,$91,$00,$0e,$ff,$fe,$91,$00
 .db $0e,$7f,$fc,$91,$00,$0e,$ff,$fc,$91,$00,$0c,$70
 .db $03,$3f,$f8,$91,$00,$0c,$0f,$84,$1f,$f0,$91,$00
 .db $0d,$78,$0f,$e0,$91,$00,$0d,$30,$0f,$e0,$91,$00
 .db $0b,$1c,$00,$d0,$07,$c0,$91,$00,$0b,$03,$e3,$10
 .db $03,$80,$91,$00,$0c,$1c,$10,$01,$91,$00,$0d,$04
 .db $10,$01,$91,$00,$0d,$04,$10,$91,$00,$0e,$04,$10
 .db $91,$00,$0e,$04,$10,$91,$00,$0e,$04,$91,$00,$0f
 .db $04,$91,$00,$0f,$04,$91,$00,$0f,$04,$91,$00,$4c
 .db $03,$01,$81,$00,$38,$91,$00,$03,$01,$0a,$09,$10
 .db $91,$00,$04,$02,$a9,$54,$36,$2a,$92,$b4,$6c,$03
 .db $0a,$8a,$a8,$91,$00,$04,$03,$29,$99,$55,$2a,$ab
 .db $2a,$aa,$71,$13,$92,$a8,$91,$00,$04,$02,$91,$91
 .db $01,$51,$55,$2a,$b2,$2a,$aa,$01,$20,$a2,$a8,$91
 .db $00,$04,$03,$21,$91,$91,$01,$35,$39,$1a,$22,$6a
 .db $03,$a0,$a1,$10,$91,$00,$22

.end
